package bomb;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;

public class BombBombe
{
	private BufferedImage 	iBomb, iBackground;
	private int 			x, y, xBackground, yBackground, xDiff, yDiff, width, height;
	private double			explodeTime;
	private boolean 		bOver, bPressed, bVisible, bExplode, bStart, bSelected;
	
	private BombSounds		soundsStart, soundsExplode;
	
	public BombBombe( BufferedImage iBomb, BufferedImage iBackground, int xBackground, int yBackground, File fileSoundStart, File fileSoundExplode )
	{
		super();
		this.iBomb			= iBomb;
		this.iBackground	= iBackground;
		this.xBackground	= xBackground;
		this.yBackground	= yBackground;
		this.x				= 304;
		this.y				= 224;
		this.xDiff			= 0;
		this.yDiff			= 0;
		this.width			= this.iBomb.getWidth();
		this.height			= this.iBomb.getHeight();
		this.explodeTime	= 2.0D;
		this.bOver			= false;
		this.bPressed		= false;
		this.bVisible		= true;
		this.bExplode		= false;
		this.bStart			= false;
		this.bSelected		= false;
		this.soundsStart	= new BombSounds( fileSoundStart );
		this.soundsExplode	= new BombSounds( fileSoundExplode );
	}
	
	/**
	 * @return gibt das Image der Bombe zurck
	 */
	public BufferedImage getIBomb()
	{
		return this.iBomb;
	}
	
	/**
	 * @return gibt das Image der Bombe zurck
	 */
	public BufferedImage getIBackground()
	{
		return this.iBackground;
	}
	
	/**
	 * @return gibt den X-Wert zurck, wo das Bild liegt im GameBackground
	 */
	public int getX()
	{
		return this.x;
	}

	/**
	 * setzt den x-Wert im GameBackground
	 * @param x
	 */
	public void setX( int x )
	{
		this.x		= x;
	}
	
	/**
	 * @return gibt den Y-Wert zurck, wo das Bild liegt im GameBackground
	 */
	public int getY()
	{
		return this.y;
	}
	
	/**
	 * setzt den y-Wert im GameBackground
	 * @param y
	 */
	public void setY( int y )
	{
		this.y		= y;
	}
	
	/**
	 * @return gibt den X-Wert zurck, wo das Bild liegt im Hud
	 */
	public int getXBackground()
	{
		return this.xBackground;
	}

	/**
	 * @return gibt den Y-Wert zurck, wo das Bild liegt im Hud
	 */
	public int getYBackground()
	{
		return this.yBackground;
	}
	
	/**
	 * @return gibt den XDifferenz-Wert zurck, wo das Bild liegt im GameBackground
	 */
	public int getXDiff()
	{
		return this.xDiff;
	}
	
	/**
	 * setzt den XDifferenz Wert neu
	 * @param xDiff = der neue XDifferenzWert
	 */
	public void setXDiff( int xDiff )
	{
		this.xDiff	= xDiff;
	}

	/**
	 * @return gibt den YDifferenz-Wert zurck, wo das Bild liegt im GameBackground
	 */
	public int getYDiff()
	{
		return this.yDiff;
	}
	
	/**
	 * setzt den YDifferenz Wert neu
	 * @param yDiff = der neue YDifferenzWert
	 */
	public void setYDiff( int yDiff )
	{
		this.yDiff	= yDiff;
	}
	
	/**
	 * @return gibt zurck wie gro die Bombe ist
	 */
	public int getWidth()
	{
		return this.width;
	}
	
	/**
	 * @return gibt zurck wie gro die Bombe ist
	 */
	public int getHeight()
	{
		return this.height;
	}
	
	public void setExplodeBomb()
	{
		this.soundsStart.endLoop();
		this.soundsExplode.play();
		this.bExplode	= true;
	}
	
	/**
	 * @return gibt den Explosions-Wert zurck, wann die Bombe explodiert
	 */
	public double getExplodeTime()
	{
		return this.explodeTime;
	}
	
	/**
	 * setzt die ExplosionsZeit neu
	 * @param ExplodeTime = der neue ExplosionsZeit
	 */
	public void setExplodeTime( double explodeTime )
	{
		this.explodeTime	= explodeTime;
		if ( this.explodeTime < 0.0D )
			this.explodeTime	= 0.0D;
		else if ( this.explodeTime > 9.9D )
			this.explodeTime	= 9.9D;
		this.explodeTime	= roundScale( this.explodeTime );
	}
	
	private double roundScale( double d ) 
	{
        return Math.rint( d * 10 ) / 10.;
    }
	
	/**
	 * @return gibt den bOver zurck
	 */
	public boolean getbOver()
	{
		return this.bOver;
	}
	
	/**
	 * @param bOver = der neue bOverWert
	 */
	public void setbOver( boolean bOver )
	{
		this.bOver	= bOver;
	}
	
	/**
	 * @return gibt den bPressed zurck
	 */
	public boolean getbPressed()
	{
		return this.bPressed;
	}
	
	/**
	 * @param bPressed = der neue bPressedWert
	 */
	public void setbPressed( boolean bPressed )
	{
		this.bPressed	= bPressed;
	}
	
	/**
	 * @return gibt den bVisible zurck
	 */
	public boolean getbVisible()
	{
		return this.bVisible;
	}
	
	/**
	 * @param bVisible = der neue bVisibleWert
	 */
	public void setbVisible( boolean bVisible )
	{
		this.bVisible	= bVisible;
	}
	
	/**
	 * @return gibt den bExplode zurck (also ist die Bombe schon explodiert oder nicht)
	 */
	public boolean getbExplode()
	{
		return this.bExplode;
	}
	
	/**
	 * @param bExplode = der neue bExplodeWert
	 */
	public void setbExplode( boolean bExplode )
	{
		this.bExplode	= bExplode;
	}
	
	/**
	 * @return gibt den bStart zurck (also 1 Sekunde frueher bevor die Bombe explodiert)
	 */
	public boolean getbStart()
	{
		return this.bStart;
	}
	
	/**
	 * @param bExplode = der neue bExplodeWert
	 */
	public void setbStart( boolean bStart )
	{
		if ( bStart )
			this.soundsStart.loop();
		this.bStart	= bStart;
	}
	
	/**
	 * @return gibt zurck ob die Bombe in GameBackground Selected wurde
	 */
	public boolean getbSelected()
	{
		return this.bSelected;
	}
	
	/**
	 * @param setzt den boolean Wert auf den bergebenen
	 */
	public void setbSelected( boolean bSelected )
	{
		this.bSelected = bSelected;
	}
	
	public void setReset()
	{
		this.bExplode	= false;
		this.bStart		= false;
		this.soundsStart.endLoop();
		this.soundsExplode.stop();
	}
	
	public void setHud()
	{
		this.x			= 304;
		this.y			= 224;
		this.bExplode	= false;
		this.bOver		= false;
		this.bPressed	= false;
		this.bSelected	= false;
		this.bStart		= false;
		this.bVisible	= true;
	}
	
	/**
	 * zeichnet das Bild
	 * @param g ist das graphics2D Objekt
	 * @param bHud - boolean-Wert, der angibt in welchem JPanel gemalt wird
	 */
	public void render( Graphics2D g, boolean bHud )
	{
		if ( bHud )
		{
			g.drawImage( this.iBackground, this.xBackground - 9, this.yBackground - 14 + 400, null );
			if ( this.bVisible == true )
			{
				g.drawImage( this.iBomb, this.xBackground, this.yBackground + 400, null );
			}
		} else
		{
			if ( ( !this.bExplode ) && ( !this.bVisible ) )
			{
				g.drawImage( this.iBomb, this.x, this.y, null );
				if ( this.bSelected )
				{
					g.setColor( Color.BLACK );
					g.drawRect( this.x, this.y, this.width, this.height );
				}
			}
		}
	}

}
