package bomb;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class BombBrick extends BombWall
{
	private boolean			bVisible, bBrick;
	private int				imageCount;
	private long			time;
	private BufferedImage	iExplode;
	
	public BombBrick( int x, int y, BufferedImage iPic, BufferedImage iExplode )
	{
		super( x, y, iPic );
		
		this.iExplode		= iExplode;
		this.setReset();
	}
	
	protected void setReset()
	{
		this.bVisible		= true;
		this.bBrick			= true;
		this.imageCount		= 0;
		this.time			= 0;
	}
	
	public boolean getbVisible()
	{
		return this.bVisible;
	}
	
	public boolean getbBrick()
	{
		return this.bBrick;
	}
	
	public String getMiddleHit( double sweetyX, double sweetyY, int width, int height, double xSpeed, double ySpeed )
	{
		String s 	= null;
		s			= this.getMiddleHindrance( sweetyX, sweetyY, width, height );
		return this.getString( s, xSpeed, ySpeed );
	}
	
	public String getCornerHit( double sweetyX, double sweetyY, int width, int height, double xSpeed, double ySpeed )
	{
		String s 	= null;
		s			= this.getCornerHindrance( sweetyX, sweetyY, width, height, xSpeed, ySpeed );
		return this.getString( s, xSpeed, ySpeed );
	}
	
	private String getString( String s, double xSpeed, double ySpeed )
	{
		if ( s.equals("links") )
		{
			if ( !this.bBrick )
				return "";
			if ( ( xSpeed > 3 ) || ( Math.abs( ySpeed ) > 4.5 ) )
			{
				this.bBrick			= false;
				this.time			= System.nanoTime();
				return s+"Hit";
			}
			return s;
		} else if ( s.equals( "rechts" ) )
		{
			if ( !this.bBrick )
				return "";
			if ( ( xSpeed < -3 ) || ( Math.abs( ySpeed ) > 4.5 ) )
			{
				this.bBrick			= false;
				this.time			= System.nanoTime();
				return s+"Hit";
			}
			return s;
		} else if ( s.equals("oben") )
		{
			if ( !this.bBrick )
				return "";
			if ( ( ySpeed > 4.5 ) || ( Math.abs( xSpeed ) > 3 ) )
			{
				this.bBrick			= false;
				this.time			= System.nanoTime();
				return s+"Hit";
			}
			return s;
		} else if ( s.equals( "unten" ) )
		{
			if ( !this.bBrick )
				return "";
			if ( ( ySpeed < -4.5 ) || ( Math.abs( xSpeed ) > 3 ) )
			{
				this.bBrick			= false;
				this.time			= System.nanoTime();
				return s+"Hit";
			}
			return s;
		}
		return "";
	}
	
	protected void setExplode()
	{
		if ( System.nanoTime() - this.time > 90000000 )
		{
			this.imageCount++;
			this.time		= System.nanoTime();
		}
		if ( this.imageCount > 3 )
			this.bVisible	= false;
	}
	
	public void render( Graphics2D g )
	{
		if ( this.bVisible )
		{
			if ( this.bBrick )
			{
				g.drawImage( this.getIPic(), this.getX(), this.getY(), null );
				if ( this.getbSelected() )
				{
					g.setColor( Color.RED );
					g.drawRect( this.getX(), this.getY(), this.getWidth()-1, this.getHeight()-1 );
				}
			} else
			{
				g.drawImage( this.iExplode, this.getX(), this.getY(), this.getX() + 20, this.getY() + 20, 0, this.imageCount*20, 20, (this.imageCount+1)*20,  null );
			}
		}
	}
	

}
