package bomb;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class BombButton
{

	private BufferedImage iPic;
	private int x, y, width, height;
	private boolean bOver, bPressed, bVisible;
	private String Function;
	
	public BombButton( BufferedImage iPic, int x, int y, int Width, int Height, String Function ) 
	{
		super();
		this.iPic			= iPic;
		this.x				= x;
		this.y 				= y;
		this.width 			= Width;
		this.height			= Height;
		this.Function		= Function;
		this.bOver 			= false;
		this.bPressed		= false;
		this.bVisible		= true;
	}
	
	/**
	 * @return gibt das Bild zurck
	 */
	public BufferedImage getPic()
	{
		return this.iPic;
	}
	
	/**
	 * @return gibt den X-Wert zurck, wo das Bild liegt im JPanel
	 */
	public int getx()
	{
		return this.x;
	}

	/**
	 * @return gibt den Y-Wert zurck, wo das Bild liegt im JPanel
	 */
	public int gety()
	{
		return this.y;
	}
	
	/**
	 * @return gibt zurck, wie breit das Bild ist
	 */	
	public int getWidth()
	{
		return this.width;
	}
	
	/**
	 * @return gibt zurck, wie hoch das Bild ist
	 */	
	public int getHeight()
	{
		return this.height;
	}
	
	/**
	 * @return gibt zurck, welche Funktion beim draufklicken passieren soll
	 */	
	public String getFunction()
	{
		return this.Function;
	}
	
	/**
	 * @return gibt zurck, ob die Maus ber dem Button ist
	 */	
	public boolean getbOver()
	{
		return this.bOver;
	}
	
	public void setbOver( boolean bOver )
	{
		this.bOver = bOver;
	}
	
	/**
	 * @return gibt zurck, ob die Maus gedrckt wurde auf dem Button
	 */	
	public boolean getbPressed()
	{
		return this.bPressed;
	}
	
	public void setbPressed( boolean bPressed )
	{
		this.bPressed = bPressed;
	}
	
	/**
	 * @return gibt zurck, ob der Button sichtbar ist oder nicht
	 */	
	public boolean getbVisible()
	{
		return this.bVisible;
	}
	
	public void setbVisible( boolean bVisible )
	{
		this.bVisible = bVisible;
	}
	
	/**
	 * malt den Button hin
	 */
	public void render( Graphics2D g )
	{
		if ( this.bVisible )
		{
			if ( this.bPressed ) 
				g.drawImage( this.iPic, this.x, this.y, this.x + this.width, this.y + this.height, 2*this.width, 0, 3*this.width, this.height, null);
			else if ( this.bOver )
				g.drawImage( this.iPic, this.x, this.y, this.x + this.width, this.y + this.height, 1*this.width, 0, 2*this.width, this.height, null);
			else
				g.drawImage( this.iPic, this.x, this.y, this.x + this.width, this.y + this.height, 0*this.width, 0, 1*this.width, this.height, null);
		}
	}

}
