package bomb;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.util.Vector;

public class BombEditorGround
{
	private BombEditor				bombEditor;
	
	private BombImage				bombImage;
	
	private BufferedImage			iBackground, iBrick, iBrickExplode,
									iSweetyNormal, iSweetyTime, iSweetyExplode, iWall;

	private Vector<BombSweety>		vSweety;
	private Vector<BombWall>		vWall;
	private Vector<BombFinish>		vFinish;
	private Vector<BombBrick>		vBrick;

	private boolean					bFinish;

	public BombEditorGround( BombEditor bombEditor, BombImage bombImage )
	{
		this.bombEditor		= bombEditor;
		this.bombImage		= bombImage;
		
		this.iBackground		= this.bombImage.setPicsMain( "/images/game_background.jpg", false );
		this.iSweetyNormal		= this.bombImage.setPicsMain( "/images/Sweety_Normal.png", false );
		this.iSweetyTime		= this.bombImage.setPicsMain( "/images/Sweety_Bomb.png", false );
		this.iSweetyExplode		= this.bombImage.setPicsMain( "/images/Sweety_Tod.png", false );
		this.iWall				= this.bombImage.setPicsMain( "/images/Wall.png", false );
		this.iBrick				= this.bombImage.setPicsMain( "/images/Brick.png", false );
		this.iBrickExplode		= this.bombImage.setPicsMain( "/images/Brick_explode.png", false );
		
		this.vFinish			= new Vector<BombFinish>();
		this.vSweety			= new Vector<BombSweety>();
		this.vWall				= new Vector<BombWall>();
		this.vBrick				= new Vector<BombBrick>();
		
		this.bFinish			= false;
	}
	
	@SuppressWarnings("unchecked")
	public void setNewSweety()
	{
		this.vSweety.add( new BombSweety( this.iBackground.getWidth() / 2 - this.iSweetyNormal.getWidth() / 2, this.iBackground.getHeight() / 2 - this.iSweetyNormal.getHeight() / 2, this.iSweetyNormal.getWidth(), this.iSweetyNormal.getHeight(), this.iSweetyNormal, this.iSweetyTime, this.iSweetyExplode ) );
	}
	
	public Vector<BombSweety> getvSweety()
	{
		return this.vSweety;
	}
	
	public void setvSweety( Vector<BombSweety> vSweety )
	{
		this.vSweety	= vSweety;
	}
	
	public void setNewWall()
	{
		this.vWall.add( new BombWall( this.iBackground.getWidth() / 2 - this.iWall.getWidth() / 2, this.iBackground.getHeight() / 2 - this.iWall.getHeight() / 2, this.iWall ) );
	}
	
	public Vector<BombWall> getvWall()
	{
		return this.vWall;
	}
	
	public void setvWall( Vector<BombWall> vWall )
	{
		this.vWall		= vWall;
	}
	
	public void setNewBrick()
	{
		this.vBrick.add( new BombBrick( this.iBackground.getWidth() / 2 - this.iWall.getWidth() / 2, this.iBackground.getHeight() / 2 - this.iWall.getHeight() / 2, this.iBrick, this.iBrickExplode ) );
	}
	
	public Vector<BombBrick> getvBrick()
	{
		return this.vBrick;
	}
	
	public void setvBrick( Vector<BombBrick> vBrick )
	{
		this.vBrick		= vBrick;
	}
	
	public Vector<BombFinish> getvFinish()
	{
		return this.vFinish;
	}
	
	public void setvFinish( Vector<BombFinish> vFinish )
	{
		this.vFinish	= vFinish;
	}
	
	public void setbFinish( boolean bFinish )
	{
		this.bFinish	= bFinish;
		if ( this.bFinish == true )
		{
			this.vFinish.add( new BombFinish( this.iBackground.getWidth() / 2 - 40, this.iBackground.getHeight() / 2 - 40, 24, 24 ) );
		}
	}
	
	public void mouseReleasedRight( int x, int y )
	{
		for ( int i = 0; i < this.vSweety.size(); i++ )
		{
			if ( 	((this.vSweety.get(i)).getX() <= x) &&
					((this.vSweety.get(i)).getX() + ((this.vSweety.get(i)).getWidth()) > x) && 
					((this.vSweety.get(i)).getY() <= y) &&
					((this.vSweety.get(i)).getY() + ((this.vSweety.get(i)).getHeight()) > y) )
			{
				this.vSweety.remove( i );
				this.bombEditor.setDeleteSelected( 1000 + i + 1 );
				return;
			}
		}
		for ( int i = 0; i < this.vFinish.size(); i++ )
		{
			if ( 	((this.vFinish.get(i)).getX() <= x) &&
					((this.vFinish.get(i)).getX() + ((this.vFinish.get(i)).getWidth()) > x) && 
					((this.vFinish.get(i)).getY() <= y) &&
					((this.vFinish.get(i)).getY() + ((this.vFinish.get(i)).getHeight()) > y) )
			{
				this.vFinish.remove( i );
				this.bombEditor.setDeleteSelected( 2000 + i + 1 );
				return;
			}
		}
		for ( int i = 0; i < this.vWall.size(); i++ )
		{
			if ( 	((this.vWall.get(i)).getX() <= x) &&
					((this.vWall.get(i)).getX() + ((this.vWall.get(i)).getWidth()) > x) && 
					((this.vWall.get(i)).getY() <= y) &&
					((this.vWall.get(i)).getY() + ((this.vWall.get(i)).getHeight()) > y) )
			{
				this.vWall.remove( i );
				this.bombEditor.setDeleteSelected( i + 1 );
				return;
			}
		}
		for ( int i = 0; i < this.vBrick.size(); i++ )
		{
			if ( 	((this.vBrick.get(i)).getX() <= x) &&
					((this.vBrick.get(i)).getX() + ((this.vBrick.get(i)).getWidth()) > x) && 
					((this.vBrick.get(i)).getY() <= y) &&
					((this.vBrick.get(i)).getY() + ((this.vBrick.get(i)).getHeight()) > y) )
			{
				this.vBrick.remove( i );
				this.bombEditor.setDeleteSelected( 3000 + i + 1 );
				return;
			}
		}
		this.bombEditor.setDeleteSelected( -1 );
	}
	
	public void mouseReleased( int x, int y )
	{
		for ( int i = 0; i < this.vFinish.size(); i++ )
		{
			if ( 	((this.vFinish.get(i)).getX() <= x) &&
					((this.vFinish.get(i)).getX() + ((this.vFinish.get(i)).getWidth()) > x) && 
					((this.vFinish.get(i)).getY() <= y) &&
					((this.vFinish.get(i)).getY() + ((this.vFinish.get(i)).getHeight()) > y) )
			{
				(this.vFinish.get(i)).setbPressed( false );
				return;
			}
		}
		for ( int i = 0; i < this.vSweety.size(); i++ )
		{
			if ( 	((this.vSweety.get(i)).getX() <= x) &&
					((this.vSweety.get(i)).getX() + ((this.vSweety.get(i)).getWidth()) > x) && 
					((this.vSweety.get(i)).getY() <= y) &&
					((this.vSweety.get(i)).getY() + ((this.vSweety.get(i)).getHeight()) > y) )
			{
				(this.vSweety.get(i)).setbPressed( false );
				return;
			}
		}
		for ( int i = 0; i < this.vWall.size(); i++ )
		{
			if ( 	((this.vWall.get(i)).getX() <= x) &&
					((this.vWall.get(i)).getX() + ((this.vWall.get(i)).getWidth()) > x) && 
					((this.vWall.get(i)).getY() <= y) &&
					((this.vWall.get(i)).getY() + ((this.vWall.get(i)).getHeight()) > y) )
			{
				(this.vWall.get(i)).setbPressed( false );
				return;
			}
		}
		for ( int i = 0; i < this.vBrick.size(); i++ )
		{
			if ( 	((this.vBrick.get(i)).getX() <= x) &&
					((this.vBrick.get(i)).getX() + ((this.vBrick.get(i)).getWidth()) > x) && 
					((this.vBrick.get(i)).getY() <= y) &&
					((this.vBrick.get(i)).getY() + ((this.vBrick.get(i)).getHeight()) > y) )
			{
				(this.vBrick.get(i)).setbPressed( false );
				return;
			}
		}
		this.bombEditor.setDeleteSelected( -1 );
	}
	
	public void mousePressed( int x, int y )
	{
		for ( int i = 0; i < this.vSweety.size(); i++ )
		{
			if ( 	((this.vSweety.get(i)).getX() <= x) &&
					((this.vSweety.get(i)).getX() + ((this.vSweety.get(i)).getWidth()) > x) && 
					((this.vSweety.get(i)).getY() <= y) &&
					((this.vSweety.get(i)).getY() + ((this.vSweety.get(i)).getHeight()) > y) )
			{
				this.bombEditor.setSelected( 1000 + i + 1 );
				(this.vSweety.get(i)).setbPressed( true );
				(this.vSweety.get(i)).setXDiff( x );
				(this.vSweety.get(i)).setYDiff( y );
				break;
			}
		}
		for ( int i = 0; i < this.vWall.size(); i++ )
		{
			if ( 	((this.vWall.get(i)).getX() <= x) &&
					((this.vWall.get(i)).getX() + ((this.vWall.get(i)).getWidth()) > x) && 
					((this.vWall.get(i)).getY() <= y) &&
					((this.vWall.get(i)).getY() + ((this.vWall.get(i)).getHeight()) > y) &&
					(!(this.vWall.get(i)).getbPressed()))
			{
				this.bombEditor.setSelected( i + 1 );
				(this.vWall.get(i)).setbPressed( true );
				(this.vWall.get(i)).setXDiff( x );
				(this.vWall.get(i)).setYDiff( y );
			} else if ( (((this.vWall.get(i)).getX() > x) ||
						 ((this.vWall.get(i)).getX() + ((this.vWall.get(i)).getWidth()) < x) || 
						 ((this.vWall.get(i)).getY() > y) ||
						 ((this.vWall.get(i)).getY() + ((this.vWall.get(i)).getHeight()) < y) ) &&
						((!(this.vWall.get(i)).getbPressed())))
			{
				(this.vWall.get(i)).setbPressed( false );
			}
		}
		for ( int i = 0; i < this.vBrick.size(); i++ )
		{
			if ( 	((this.vBrick.get(i)).getX() <= x) &&
					((this.vBrick.get(i)).getX() + ((this.vBrick.get(i)).getWidth()) > x) && 
					((this.vBrick.get(i)).getY() <= y) &&
					((this.vBrick.get(i)).getY() + ((this.vBrick.get(i)).getHeight()) > y) &&
					(!(this.vBrick.get(i)).getbPressed()))
			{
				this.bombEditor.setSelected( 3000 + i + 1 );
				(this.vBrick.get(i)).setbPressed( true );
				(this.vBrick.get(i)).setXDiff( x );
				(this.vBrick.get(i)).setYDiff( y );
			} else if ( (((this.vBrick.get(i)).getX() > x) ||
						 ((this.vBrick.get(i)).getX() + ((this.vBrick.get(i)).getWidth()) < x) || 
						 ((this.vBrick.get(i)).getY() > y) ||
						 ((this.vBrick.get(i)).getY() + ((this.vBrick.get(i)).getHeight()) < y) ) &&
						((!(this.vBrick.get(i)).getbPressed())))
			{
				(this.vBrick.get(i)).setbPressed( false );
			}
		}
		for ( int i = 0; i < this.vFinish.size(); i++ )
		{
			if ( 	((this.vFinish.get(i)).getX() <= x) &&
					((this.vFinish.get(i)).getX() + ((this.vFinish.get(i)).getWidth()) > x) && 
					((this.vFinish.get(i)).getY() <= y) &&
					((this.vFinish.get(i)).getY() + ((this.vFinish.get(i)).getHeight()) > y) &&
					(!(this.vFinish.get(i)).getbPressed()) )
			{
				(this.vFinish.get(i)).setbPressed( true );
				(this.vFinish.get(i)).setXDiff( x );
				(this.vFinish.get(i)).setYDiff( y );
				this.bombEditor.setSelected( 2000 + i + 1 );
				break;
			}
		}
	}
	
	public void mouseMoved( int x, int y )
	{
	}
	
	public void mouseDragged( int x, int y )
	{
		for ( int i = 0; i < this.vFinish.size(); i++ )
		{
			if ( 	((this.vFinish.get(i)).getbPressed()) )
			{
				if ( 	( ( x - (this.vFinish.get(i)).getXDiff() ) + (this.vFinish.get(i)).getWidth() <= 640 ) &&
						( ( x - (this.vFinish.get(i)).getXDiff() ) >= 0 ) )
					(this.vFinish.get(i)).setX( ( x - (this.vFinish.get(i)).getXDiff() ) );
				if ( 	( ( y - (this.vFinish.get(i)).getYDiff() ) + (this.vFinish.get(i)).getHeight() <= 400 ) &&
						( ( y - (this.vFinish.get(i)).getYDiff() ) >= 0 ) )
					(this.vFinish.get(i)).setY( ( y - (this.vFinish.get(i)).getYDiff() ) );
				this.bombEditor.setSelected( 2000 + i + 1 );
				return;
			}
		}
		for ( int i = 0; i < this.vWall.size(); i++ )
		{
			if ( (this.vWall.get(i)).getbPressed() )
			{
				for ( int j = 0; j < this.vWall.size(); j++ )
				{
					if ( ( i != j ) && (this.vWall.get(j)).getbWallHit( x - (this.vWall.get(i)).getXDiff(), y - (this.vWall.get(i)).getYDiff(), (this.vWall.get(i)).getWidth(), (this.vWall.get(i)).getHeight() ) )
						return;
				}
				for ( int j = 0; j < this.vBrick.size(); j++ )
				{
					if ( ((BombBrick)this.vBrick.get(j)).getbWallHit( x - (this.vWall.get(i)).getXDiff(), y - (this.vWall.get(i)).getYDiff(), (this.vWall.get(i)).getWidth(), (this.vWall.get(i)).getHeight() ) )
						return;
				}
				if ( ( ( x - (this.vWall.get(i)).getXDiff() ) + (this.vWall.get(i)).getWidth() <= 640 ) &&
					 ( ( x - (this.vWall.get(i)).getXDiff() ) >= 0 ) )
						(this.vWall.get(i)).setX( x - (this.vWall.get(i)).getXDiff() );
				if ( ( ( y - (this.vWall.get(i)).getYDiff() ) + (this.vWall.get(i)).getHeight() <= 400 ) &&
					 ( ( y - (this.vWall.get(i)).getYDiff() ) >= 0 ) )
						(this.vWall.get(i)).setY( y - (this.vWall.get(i)).getYDiff()  );
				this.bombEditor.setSelected( i + 1 );
				return;
			}
		}
		for ( int i = 0; i < this.vBrick.size(); i++ )
		{
			if ( ((BombBrick)this.vBrick.get(i)).getbPressed() )
			{
				for ( int j = 0; j < this.vWall.size(); j++ )
				{
					if ( (this.vWall.get(j)).getbWallHit( x - ((BombBrick)this.vBrick.get(i)).getXDiff(), y - ((BombBrick)this.vBrick.get(i)).getYDiff(), ((BombBrick)this.vBrick.get(i)).getWidth(), ((BombBrick)this.vBrick.get(i)).getHeight() ) )
						return;
				}
				for ( int j = 0; j < this.vBrick.size(); j++ )
				{
					if ( ( i != j ) && ((BombBrick)this.vBrick.get(j)).getbWallHit( x - ((BombBrick)this.vBrick.get(i)).getXDiff(), y - ((BombBrick)this.vBrick.get(i)).getYDiff(), ((BombBrick)this.vBrick.get(i)).getWidth(), ((BombBrick)this.vBrick.get(i)).getHeight() ) )
						return;
				}
				if ( ( ( x - ((BombBrick)this.vBrick.get(i)).getXDiff() ) + ((BombBrick)this.vBrick.get(i)).getWidth() <= 640 ) &&
					 ( ( x - ((BombBrick)this.vBrick.get(i)).getXDiff() ) >= 0 ) )
							((BombBrick)this.vBrick.get(i)).setX( x - ((BombBrick)this.vBrick.get(i)).getXDiff() );
				if ( ( ( y - ((BombBrick)this.vBrick.get(i)).getYDiff() ) + ((BombBrick)this.vBrick.get(i)).getHeight() <= 400 ) &&
					 ( ( y - ((BombBrick)this.vBrick.get(i)).getYDiff() ) >= 0 ) )
						((BombBrick)this.vBrick.get(i)).setY( y - ((BombBrick)this.vBrick.get(i)).getYDiff()  );
				this.bombEditor.setSelected( 3000 + i + 1 );
				return;
			}
		}
		for ( int i = 0; i < this.vSweety.size(); i++ )
		{
			if ( (this.vSweety.get(i)).getbPressed() )
			{
				if ( ( ( x - (this.vSweety.get(i)).getXDiff() ) + (this.vSweety.get(i)).getWidth() <= 640 ) &&
					 ( ( x - (this.vSweety.get(i)).getXDiff() ) >= 0 ) )
						(this.vSweety.get(i)).setX( x - (this.vSweety.get(i)).getXDiff() );
				if ( ( ( y - (this.vSweety.get(i)).getYDiff() ) + (this.vSweety.get(i)).getHeight() <= 400 ) &&
					 ( ( y - (this.vSweety.get(i)).getYDiff() ) >= 0 ) )
						(this.vSweety.get(i)).setY( y - (this.vSweety.get(i)).getYDiff()  );
				this.bombEditor.setSelected( 1000 + i + 1 );
				return;
			}
		}
	}

	public void keyReleased( int key )
	{
		
	}
	
	public void render( Graphics2D gfx ) 
	{
		gfx.drawImage( this.iBackground, 0, 0, null );
		for ( int i = 0; i < this.vWall.size(); i++ )
		{
			(this.vWall.get(i)).render( gfx );
		}
		for ( int i = 0; i < this.vBrick.size(); i++ )
		{
			((BombBrick)this.vBrick.get(i)).render( gfx );
		}
		for ( int i = 0; i < this.vFinish.size(); i++ )
		{
			(this.vFinish.get(i)).render( gfx );
		}
		for ( int i = 0; i < this.vSweety.size(); i++ )
		{
			(this.vSweety.get(i)).render( gfx );
		}
	}

}
