package bomb;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

public class BombFinish
{

	private int 		x, y, width, height, pressX, pressY, xDiff, yDiff;
	private boolean		bPressed, bSelected;
	
	public BombFinish( int x, int y, int width, int height )
	{
		super();
		this.x			= x;
		this.y			= y;
		this.width		= width;
		this.height		= height;
		this.pressX		= 0;
		this.pressY		= 0;
		this.xDiff		= 0;
		this.yDiff		= 0;
		
		this.bPressed	= false;
		this.bSelected	= false;
	}
	
	public boolean getbSelected()
	{
		return this.bSelected;
	}
	
	public void setbSelected( boolean bSelected )
	{
		this.bSelected	= bSelected;
	}
	
	public int getX()
	{
		return this.x;
	}
	
	protected void setX( double x )
	{
		this.x	= (int)x;
	}
	
	public int getY()
	{
		return this.y;
	}
	
	protected void setY( double y )
	{
		this.y	= (int)y;
	}
	
	public double getXDiff() 
    {
        return this.xDiff;
    }
    
	public void setXDiff( double x )
    {
    	this.xDiff	= (int)x - this.x;
    }
	
	public double getYDiff() 
    {
        return this.yDiff;
    }
    
	public void setYDiff( double y )
    {
    	this.yDiff	= (int)y - this.y;
    }
	
	public int getWidth()
	{
		return this.width;
	}
	
	protected void setWidth( int width )
	{
		this.width	= width;
	}
	
	public int getHeight()
	{
		return this.height;
	}
	
	protected void setHeight( int height )
	{
		this.height	= height;
	}
	
	public int getPressX()
	{
		return this.pressX;
	}
	
	public void setPressX( int pressX )
	{
		this.pressX	= pressX;;
	}
	
	public int getPressY()
	{
		return this.pressY;
	}
	
	public void setPressY( int pressY )
	{
		this.pressY	= pressY;;
	}
	
	public boolean getbPressed()
	{
		return this.bPressed;
	}
	
	public void setbPressed( boolean bPressed )
	{
		this.bPressed	= bPressed;
	}
	
	public boolean getbFinishHit( double sweetyX, double sweetyY, int width, int height )
	{
		Rectangle2D a = new Rectangle2D.Double( this.x , this.y , this.width , this.height );
		Rectangle2D b = new Rectangle2D.Double( sweetyX + width/2, sweetyY + height/2, 1, 1 );
		return a.intersects(b);
	}
	
	public void render( Graphics2D g )
	{
		if ( !this.bPressed )
		{
			g.setColor( Color.BLACK );
			g.drawRect( this.x - 1, this.y - 1, this.width + 1, this.height + 1 );
			g.setColor( Color.WHITE );
			g.drawRect( this.x, this.y, this.width-1, this.height-1 );
			g.setColor( Color.BLACK );
			g.drawRect( this.x + 1, this.y + 1, this.width - 3, this.height - 3 );
		} else
		{
			g.setColor( Color.BLACK );
			g.drawRect( this.x - 1, this.y - 1, this.width + 1, this.height + 1 );
			g.setColor( Color.WHITE );
			g.drawRect( this.x, this.y, this.width-1, this.height-1 );
			g.setColor( Color.BLACK );
			g.drawRect( this.x + 1, this.y + 1, this.width - 3, this.height - 3 );
		}
		if ( this.bSelected )
		{
			g.setColor( Color.RED );
			g.drawRect( this.x, this.y, this.width - 1, this.height - 1 );
		}
	}

}
