package bomb;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class BombGameHudDrag
{
	private BufferedImage		iBackground, iDrag;
	private int					x, y, xDiff, xMouse, width, height;
	private boolean 			bOver, bPressed;
	
	public BombGameHudDrag( BufferedImage iBackground, BufferedImage iDrag, int x, int y )
	{
		super();
		
		this.iBackground		= iBackground;
		this.iDrag				= iDrag;
		this.x					= x;
		this.y					= y;
		this.width				= this.iDrag.getWidth();
		this.height				= this.iDrag.getHeight();
		this.xMouse				= 0;
		this.xDiff				= 20;
	}

	/**
	 * @return gibt zurck, wie breit das Bild ist
	 */	
	public int getWidth()
	{
		return this.width;
	}
	
	/**
	 * @return gibt zurck, wie hoch das Bild ist
	 */	
	public int getHeight()
	{
		return this.height;
	}
	
	/**
	 * @return gibt den X-Wert zurck, wo das Bild liegt im JPanel
	 */
	public int getX()
	{
		return this.x + this.xDiff;
	}

	/**
	 * @return gibt den Y-Wert zurck, wo das Bild liegt im JPanel
	 */
	public int getY()
	{
		return this.y;
	}
	
	/**
	 * @return gibt zurck, ob die Maus ber dem Button ist
	 */	
	public boolean getbOver()
	{
		return this.bOver;
	}
	
	public void setbOver( boolean bOver )
	{
		this.bOver = bOver;
	}
	
	/**
	 * @return gibt zurck, ob die Maus gedrckt wurde auf dem Button
	 */	
	public boolean getbPressed()
	{
		return this.bPressed;
	}
	
	public void setbPressed( boolean bPressed )
	{
		this.bPressed = bPressed;
	}
	
	public void setXMouse( int x )
	{
		this.xMouse		= x - this.x - this.xDiff;
	}
	
	public void setXDiff( int x, boolean bButton )
	{
		if ( bButton == true )
			this.xDiff	= this.xDiff + x;
		else
			this.xDiff	= x;
	}
	
	public void setXDiff( int x )
	{
		this.xDiff	= x - this.x - this.xMouse;
		if ( this.xDiff < 0 )
			this.xDiff	= 0;
		else if ( this.xDiff > this.iBackground.getWidth() - this.iDrag.getWidth() - 2 )
			this.xDiff	= this.iBackground.getWidth() - this.iDrag.getWidth() - 2;
	}
	
	public int getXDiff()
	{
		return this.xDiff;
	}
	
	public void render( Graphics2D gfx )
	{
		gfx.drawImage( this.iBackground, this.x - 1, this.y - 1, null );
		gfx.drawImage( this.iDrag, this.x + this.xDiff, this.y, null );
	}

}
