package bomb;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.HeadlessException;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.PixelGrabber;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

public class BombImage implements ImageObserver
{

	private Component 	C;
	private int			width, height;
	private GraphicsConfiguration gc;
	
	public BombImage( Component C ) 
	{
		super();
		this.C					= C;
		this.gc					= GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
		// TODO Auto-generated constructor stub
	}
	
	public int getWidth()
	{
		return this.width;
	}
	
	public int getHeight()
	{
		return this.height;
	}
	
	public BufferedImage setPicsMain( String BildString, boolean bLoad ) 
	{
		BufferedImage i;
		MediaTracker mt;
		mt = new MediaTracker( C );// damit alles mit einmal angezeigt wird
		
		i = getImage( BildString, bLoad );

		mt.addImage(i, 0);

		try
		{
			// Wait until all pic are load,
			mt.waitForAll();
		} catch (InterruptedException e) 
		{
			// nothing
		}
		this.width	= i.getWidth( null );
		this.height	= i.getHeight( null );
		return i;
	}
	
	private BufferedImage getImage(String BildName, boolean bLoad )
	{
		BufferedImage icon;
		
		BufferedImage result	= null;
		BufferedImage img		= null;
		
		if ( !bLoad ) 
		{
			try
			{
				img = ImageIO.read( BombImage.class.getResource( BildName ) );
			} catch (IOException e)
			{
				e.printStackTrace();
			}
			result = this.gc.createCompatibleImage(img.getWidth(),img.getHeight(), Transparency.TRANSLUCENT);
			result.createGraphics().drawImage(img,0,0,null);
			icon	= result;
			
		} else
		{
			img = getBufferedImage( new ImageIcon(BildName).getImage() );
			result = this.gc.createCompatibleImage(img.getWidth(),img.getHeight(), Transparency.TRANSLUCENT);
			result.createGraphics().drawImage(img,0,0,null);
			icon	= result;
		}
		return (icon);
	}	
	
	public BufferedImage getBufferedImage(Image img)
	{
		return toBufferedImage(img);
	}
	
    // Hilfsmethode fr Umwandlung des Bildes
    private boolean hasAlpha(Image image) 
    {
        if (image instanceof BufferedImage) 
        {
            BufferedImage bImage = (BufferedImage) image;
            return bImage.getColorModel().hasAlpha();
        }

        PixelGrabber pixelGrabber = new PixelGrabber(image, 0, 0, 1, 1, false);
        try 
        {
            pixelGrabber.grabPixels();
        } catch (InterruptedException e) 
        {}

        ColorModel colorModel = pixelGrabber.getColorModel();
        return colorModel.hasAlpha();
    }

    // Umwandlung eines Image in ein BufferedImage
    private BufferedImage toBufferedImage(Image image) 
    {
        if (image instanceof BufferedImage) 
        {
            return (BufferedImage) image;
        }

        image = new ImageIcon(image).getImage();

        boolean hasAlpha = hasAlpha(image);

        BufferedImage bImage = null;
        GraphicsEnvironment ge = GraphicsEnvironment
                .getLocalGraphicsEnvironment();
        try 
        {
            int transparency = Transparency.OPAQUE;
            if (hasAlpha)
                transparency = Transparency.BITMASK;

            GraphicsDevice gs = ge.getDefaultScreenDevice();
            GraphicsConfiguration gc = gs.getDefaultConfiguration();
            bImage = gc.createCompatibleImage(image.getWidth(null), image
                    .getHeight(null), transparency);
        } catch (HeadlessException e) 
        {}

        if (bImage == null) 
        {
            int type = BufferedImage.TYPE_INT_RGB;
            if (hasAlpha)
                type = BufferedImage.TYPE_INT_ARGB;
            bImage = new BufferedImage(image.getWidth(null), image
                    .getHeight(null), type);
        }

        Graphics g = bImage.createGraphics();

        g.drawImage(image, 0, 0, this);
        g.dispose();
        return bImage;
    }

	public boolean imageUpdate(Image arg0, int arg1, int arg2, int arg3, int arg4, int arg5)
	{
		return false;
	}

}
