package bomb;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class BombMenu implements BombInterface
{
	/** The time at which the last rendering looped started from the point of view of the game logic */
	private long lastLoopTime = BombSystemTimer.getTime();
	
	private BombMain 		bombMain;
	
	private BombImage		bombImage;
	
	private BombButton[]	Buttons;
	
	private BufferedImage	iBackground;
	
	public boolean			bLogic;
	
	public BombMenu( BombMain bombMain, BombImage bombImage )
	{
		this.bombMain		= bombMain;
		this.bombImage		= bombImage;
		
		this.iBackground		= this.bombImage.setPicsMain( "/images/menu_background.jpg", false );
		
		this.Buttons			= new BombButton[4];
		this.Buttons[0]			= new BombButton( this.bombImage.setPicsMain( "/images/menu_button_quit.png", false ),    570, 410,  60, 60, "Quit" );
		this.Buttons[1]			= new BombButton( this.bombImage.setPicsMain( "/images/menu_button_game.png", false ),    215, 205, 200, 60, "Game" );
		this.Buttons[2]			= new BombButton( this.bombImage.setPicsMain( "/images/menu_button_editor.png", false ),  215, 285, 200, 60, "Editor" );
		this.Buttons[3]			= new BombButton( this.bombImage.setPicsMain( "/images/menu_button_options.png", false ), 215, 365, 200, 60, "Options" );
		
		this.bLogic			= false;
	}

	public Dimension getPreferredSize()
	{
		return new Dimension( 640, 480);
	}
	
	public boolean getRenderAble()
	{
		return false;
	}

	public boolean getLogicAble()
	{
		return this.bLogic;
	}

	public void frameRenderer( Graphics2D g )
	{
		BombSystemTimer.sleep(lastLoopTime+10-BombSystemTimer.getTime());
		
		// work out how long its been since the last update
		lastLoopTime = BombSystemTimer.getTime();
		
		this.logic();
		
		this.render( g );
	}

	public void logic()
	{
		if ( this.getLogicAble() )
		{
		}
	}
	
	public void mousePressed( int x, int y )
	{
		for (int i = 0; i < Buttons.length; i++)
		{
			if ( (Buttons[i].getbVisible() == true) && (Buttons[i].getbOver() == true) && (Buttons[i].getx() <= x) &&
				 (Buttons[i].getx() + Buttons[i].getWidth() > x) && (Buttons[i].gety() <= y) &&
				 (Buttons[i].gety() + Buttons[i].getHeight() > y))
			{
				Buttons[i].setbPressed( true );
				break;
			}
		}
	}

	public void mouseReleased( int x, int y )
	{
		for (int i = 0; i < Buttons.length; i++)
		{
			if ( (Buttons[i].getbPressed() == true) && (Buttons[i].getx() <= x) &&
				 (Buttons[i].getx() + Buttons[i].getWidth() > x) && (Buttons[i].gety() <= y) &&
				 (Buttons[i].gety() + Buttons[i].getHeight() > y) && (Buttons[i].getbVisible() == true))
			{
				Buttons[i].setbPressed( false );
				if (Buttons[i].getFunction().equals("Quit"))
				{
					System.exit( 0 );
				}
				else if (Buttons[i].getFunction().equals("Game"))
				{
					this.bombMain.setGame();
				}
				else if (Buttons[i].getFunction().equals("Editor"))
				{
					this.bombMain.setEditor();
				}
				else if (Buttons[i].getFunction().equals("Options"))
				{
				}
			} else
			{
				Buttons[i].setbOver( false );
				Buttons[i].setbPressed( false );
			}
		}
	}

	public void mouseMoved( int x, int y )
	{
		for (int i = 0; i < Buttons.length; i++)
		{
			if ( (Buttons[i].getbVisible() == true) && (Buttons[i].getbOver() == false) && (Buttons[i].getx() <= x) &&
				 (Buttons[i].getx() + Buttons[i].getWidth() > x) && (Buttons[i].gety() <= y) &&
				 (Buttons[i].gety() + Buttons[i].getHeight() > y))
			{
				Buttons[i].setbOver( true );
			} else if (	(Buttons[i].getbOver() == true) && ((Buttons[i].getx() > x) ||
					 	(Buttons[i].getx() + Buttons[i].getWidth() <= x) || (Buttons[i].gety() > y) ||
					 	(Buttons[i].gety() + Buttons[i].getHeight() <= y)) )
			{
				Buttons[i].setbOver( false );
				Buttons[i].setbPressed( false );
			}
		}
	}

	public void render(Graphics2D gfx) 
	{
		gfx.drawImage( this.iBackground, 0, 0, null );
		for ( int i = 0; i < this.Buttons.length; i++ )
		{
			this.Buttons[i].render( gfx );
		}
	}

}
