package bomb;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;

public class BombSweety
{
	private static final double		counter		= 1.25;
	private static final double		gravitation	= 9.81;
	private double					x, y, xSpeed, ySpeed, rotate, xStart, yStart, xDiff, yDiff;
	private int						width, height, random;
	private boolean					bPressed, bSelected;
	private BufferedImage			iPic, iNormal, iTime, iExplode;
	
	private BombSpeedCalculation	bSC;
	
	private BombSounds 				soundHuh;
	private BombSounds[]			aSoundScream;
	
	public BombSweety( double x, double y, int width, int height, BufferedImage iPic, BufferedImage iTime, BufferedImage iExplode )
	{
		super();
		
		this.x				= x;
		this.y				= y;
		this.xStart			= x;
		this.yStart			= y;
		this.xSpeed			= 0.0D;
		this.ySpeed			= 0.0D;
		this.width			= width;
		this.height			= height;
		this.iPic			= iPic;
		this.iNormal		= iPic;
		this.iTime			= iTime;
		this.iExplode		= iExplode;
		this.bPressed		= false;
		this.bSelected		= false;
		this.xDiff			= 0;
		this.yDiff			= 0;
		this.rotate			= 0;
		
		this.bSC			= new BombSpeedCalculation();
		
		this.soundHuh       = new BombSounds(new File( System.getProperty("user.dir")+"/sounds/Huh.wav"));
	}

	public boolean getbPressed()
	{
		return this.bPressed;
	}
	
	public void setbPressed( boolean bPressed )
	{
		this.bPressed	= bPressed;
	}
	
	public boolean getbSelected()
	{
		return this.bSelected;
	}
	
	public void setbSelected( boolean bSelected )
	{
		this.bSelected	= bSelected;
	}
	
	public double getXDiff() 
    {
        return this.xDiff;
    }
    
	public void setXDiff( double x )
    {
    	this.xDiff	= x - this.x;
    }
	
	public double getYDiff() 
    {
        return this.yDiff;
    }
    
	public void setYDiff( double y )
    {
    	this.yDiff	= y - this.y;
    }
	
	public double getX() 
    {
        return this.x;
    }
    
	public void setX( double x )
    {
    	this.x	= x;
    }
	
    public double getY()
    {
        return this.y;
    }
    
    public void setY( double y )
    {
    	this.y	= y;
    }
    
    public int getWidth()
    {
        return this.width;
    }
    
    public int getHeight()
    {
        return this.height;
    }
    
    public double getXSpeed()
    {
        return this.xSpeed;
    }
    
    public double getYSpeed()
    {
        return this.ySpeed;
    }
    
    public void setYSpeed()
    {
    	this.ySpeed		+= ( gravitation * 0.005 );
    }
    
    public BufferedImage getImage()
    {
        return this.iPic;
    }
    
    public void setImage( BufferedImage iPic )
    {
        this.iPic = iPic;
    }
    
    public void setTime()
    {
    	this.soundHuh.play();
    	this.iPic	= this.iTime;
    }
    
    public void setExplode()
    {
    	this.soundHuh.stop();
    	this.random	= (int)( Math.random() * this.aSoundScream.length );
    	this.aSoundScream[random].play();
    	this.iPic	= this.iExplode;
    }
    
    public void setSoundScream( BombSounds[] aSoundScream )
    {
    	this.aSoundScream	= aSoundScream.clone();
    }
    
    public void setReset()
    {
    	this.iPic	= this.iNormal;
    	this.x		= this.xStart;
    	this.y		= this.yStart;
    	this.xSpeed	= 0.0D;
    	this.ySpeed	= 0.0D;
    	this.rotate	= 0.0D;
    	this.aSoundScream[this.random].stop();
    	this.soundHuh.stop();
    }
	
    public void think()
    {
    	this.rotate		+= 3 * this.xSpeed;
		if ( this.rotate > 360.0D )
			this.rotate	= this.rotate - 360.0D;
		if ( this.xSpeed != 0) 
        {
			if ( this.xSpeed > 10 )
				this.xSpeed	= 10;
            this.x = this.x + this.xSpeed * counter;
            if (Math.abs(this.ySpeed) < 0.05)
            {
            	this.xSpeed = this.xSpeed * 0.992;
            } else
            {
            	this.xSpeed = this.xSpeed * 0.998;
            }
            if (Math.abs(this.xSpeed) < 0.05)
            {
            	this.xSpeed = 0;
            }
        }
        if ( this.ySpeed != 0) 
        {
        	if ( this.ySpeed > 10 )
        		this.ySpeed	= 10;
        	this.y 		= this.y + this.ySpeed * counter;
        	this.ySpeed = this.ySpeed + ( gravitation * 0.005 );
        }
    }
    
    public void setTimeCheck( double xBomb, double yBomb )
    {
    	double xMiddle		= this.x + this.width / 2;
    	double yMiddle		= this.y + this.height / 2;
    	if (	( xBomb < xMiddle - 50 ) || ( xBomb > xMiddle + 50 ) ||
    			( yBomb < yMiddle - 50 ) || ( yBomb > yMiddle + 50 ) )
    	{} else
    	{
    		this.setTime();
    	}
    }
    
    public void setSpeedCalculation( double xBomb, double yBomb )
    {
    	this.bSC.setSpeedCalculation( (int)this.x, (int)this.y, this.width, this.height, this.xSpeed, this.ySpeed, (int)xBomb, (int)yBomb );
    	if ( ( this.xSpeed != this.bSC.getXSpeed() ) || ( this.ySpeed != this.bSC.getYSpeed() ) )
    		this.setExplode();
    	this.xSpeed		= this.bSC.getXSpeed();
    	this.ySpeed		= this.bSC.getYSpeed();
    }
    
    public void setHindrance( String hindrance, double wallX, double wallY, int wallWidth, int wallHeight )
    {
    	if ( "links".equals(hindrance) || "rechts".equals(hindrance) ) 
    	{
    		if ( "links".equals(hindrance) )
    		{
    			if ( 0 <= this.xSpeed )
    			{
    				this.xSpeed		= this.xSpeed * ( -0.95 );
    				if ( this.x + this.width > wallX )
    					this.x	= wallX - this.width;
    			}
    		} else
    		{
    			if ( this.xSpeed < 0 )
    			{
    				this.xSpeed		= this.xSpeed * ( -0.95 );
    				if ( this.x < wallX + wallWidth )
    					this.x	= wallX + wallWidth;
    			}
    		}
    	} else if ( "oben".equals(hindrance) )
    	{
    		if ( this.ySpeed > 0 )
    		{
    			this.ySpeed = this.ySpeed * ( -0.45 );
    			if ( this.y + this.height > wallY )
    				this.y	= wallY - this.height;
    			if ( ( Math.abs( this.ySpeed ) < 0.5 ) && ( Math.abs( this.xSpeed ) < 2 ) )
    				this.ySpeed	= 0;
    		}
    	} else if ( "unten".equals(hindrance) )
    	{
    		if ( this.ySpeed < 0 )
    		{
    			this.ySpeed = this.ySpeed * ( -0.9 );
    			if ( this.y < wallY + wallHeight )
    				this.y	= wallY + wallHeight;
    		}
    	} else if ( "linksHit".equals(hindrance) || "rechtsHit".equals(hindrance) ) 
    	{
    		this.xSpeed		= this.xSpeed * 0.99;
    	} else if ( "obenHit".equals(hindrance) || "untenHit".equals(hindrance) )
    	{
    		this.ySpeed		= this.ySpeed * 0.99;
    	}
    			
    }
    
	public void render( Graphics2D gfx )
	{
		int sweetyMiddleX = (int)this.x + this.width / 2;
		int sweetyMiddleY = (int)this.y + this.height / 2;
		
		if ( this.y + this.height >= 0 )
		{
			AffineTransform copy = (AffineTransform)gfx.getTransform().clone();

			if ( 0 != this.rotate )
				gfx.setTransform( AffineTransform.getRotateInstance( Math.toRadians( this.rotate ), sweetyMiddleX, sweetyMiddleY ) );
			//gfx.drawString( ((int)this.x+this.width/2)+", "+((int)this.y+this.height/2), (int)this.x, (int)this.y );
			gfx.drawImage( this.iPic, (int)this.x, (int)this.y, null );
			gfx.setTransform( copy );
		} else
		{
			gfx.setColor( Color.BLACK );
			gfx.fillRect( sweetyMiddleX - 2, 1, 4, 4 );
		}
		
		if ( this.bSelected )
		{
			gfx.setColor( Color.RED );
			gfx.drawRect( (int)x, (int)y, this.width-1, this.height-1 );
		}
	}
	
}
