package bomb;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class BombTextField
{

	private BufferedImage		iBackground;
	private int					x, y, width, height, position;
	private String				text;
	private boolean				bVisible, bSelected, bNumber;
	
	public BombTextField( BufferedImage iBackground, boolean bNumber )
	{
		this.iBackground	= iBackground;
		this.bNumber		= bNumber;
		
		this.x				= 0;
		this.y				= 0;
		this.width			= this.iBackground.getWidth();
		this.height			= this.iBackground.getHeight();
		this.position		= 0;
		this.text			= "";
		this.bVisible		= true;
		this.bSelected		= false;
	}
	
	public BombTextField( BufferedImage iBackground, String text, boolean bNumber )
	{
		this.iBackground	= iBackground;
		this.text			= text;
		this.bNumber		= bNumber;
		
		this.x				= 0;
		this.y				= 0;
		this.width			= this.iBackground.getWidth();
		this.height			= this.iBackground.getHeight();
		this.position		= this.text.length();
		this.bVisible		= true;
		this.bSelected		= false;
	}
	
	public int getX()
	{
		return this.x;
	}
	
	public int getY()
	{
		return this.y;
	}
	
	public int getWidth()
	{
		return this.width;
	}
	
	public int getHeight()
	{
		return this.height;
	}
	
	public void setLocation( int x, int y )
	{
		this.x		= x;
		this.y		= y;
	}
	
	public void setSize( int width, int height )
	{
		this.width		= width;
		this.height		= height;
	}
	
	public boolean getSelected()
	{
		return this.bSelected;
	}
	
	public void setSelected( boolean bSelected )
	{
		this.bSelected		= bSelected;
	}
	
	public void setVisible( boolean bVisible )
	{
		this.bVisible	= bVisible;
	}
	
	public boolean getVisible()
	{
		return this.bVisible;
	}
	
	public String getText()
	{
		return this.text;
	}
	
	public void setText( String text )
	{
		this.text		= text;
		if ( this.text.length() > 10 )
			this.text.substring( 0, 10 );
		this.position	= this.text.length();
	}
	
	private void addText( char addChar )
	{
		if ( this.text.length() <= 10 )
		{
			this.text		= this.text.substring( 0, position ) + addChar + this.text.substring( this.position, this.text.length() );
			this.position	+= 1;
		}
	}
	
	private void deleteTextBackspace()
	{
		if ( ( this.text.length() > 0 ) && ( this.position != 0 ) )
		{
			this.text		= this.text.substring( 0, position - 1 ) + this.text.substring( this.position, this.text.length() );
			this.position	-= 1;
		}
	}
	
	private void deleteTextDelete()
	{
		if ( this.text.length() != this.position )
		{
			this.text		= this.text.substring( 0, position ) + this.text.substring( this.position + 1, this.text.length() );
		}
	}
	
	private void setPosition( int plusPosition )
	{
		if ( ( this.position + plusPosition >= 0 ) && ( this.position + plusPosition <= this.text.length() ) )
			this.position	+= plusPosition;
	}
	
	protected void mousePressed( int x, int y )
	{
		if ( 	( !bSelected ) && ( x > this.x ) && ( x < this.x + this.width ) &&
				( y > this.y ) && ( y < this.y + this.height ) )
		{
			this.bSelected	= true;
		} else
		{
			this.bSelected	= false;
		}
	}
	
	protected void keyReleased( int key, char character )
	{
		if ( this.bSelected )
		{
			if ( key == 8 )
				this.deleteTextBackspace();
			else if ( key == 127 )
				this.deleteTextDelete();
			else if ( key == 37 )
				this.setPosition( -1 );
			else if ( key == 39 )
				this.setPosition( 1 );
			else if ( this.bNumber )
			{
				if ( ( character >= 48 ) && ( character <= 57 ) )
					this.addText( character );
			} else
			{
				if ( 	( ( character >= 48 ) && ( character <= 57 ) ) ||
						( ( character >= 65 ) && ( character <= 90 ) ) ||
						( ( character >= 97 ) && ( character <= 122 ) ) )
				{
					this.addText( character );
				}
			}
		}
	}
	
	public void render( Graphics2D g )
	{
		if ( this.bVisible )
		{
			g.drawImage( this.iBackground, x, y, this.x + this.width, this.y + this.height, 0, 0, this.iBackground.getWidth(), this.iBackground.getHeight(), null );
			if ( this.bSelected )
			{
				g.drawRect( x, y, this.width-2, this.height-2 );
				g.drawRect( (int)(x + this.width/2 - this.text.length()*2.6 + this.position*7), y +  + this.height/2 + 5 , 1, 1 );
			}
			g.drawString( this.text, (int)(this.x + this.width/2 - this.text.length()*2.6), this.y + this.height/2 + 5 );
		}
		
	}

}
