package bomb;

import java.util.concurrent.TimeUnit;

public class BombThreadLogic implements Runnable
{
	private BombGame			bombGame;
	
	private int 				delay;
	
	private boolean 			bThread;
	
	public BombThreadLogic( BombGame bombGame, int delay )
	{
		super();

		this.bombGame	= bombGame;
		this.delay		= delay;
		
		this.bThread		= false;
	}

	/**
	 * startet den Thread
	 */
	public void start()
	{
		this.bThread	= true;
		Thread t		= new Thread( this );
		t.start();
	}
	
	/**
	 * beendet diesen Thread
	 */
	public void stop()
	{
		this.bThread	= false;
	}	
	
	public void run()
	{
		Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
		
		long	startTime	= System.nanoTime();

		while ( this.bThread )
		{
			this.bombGame.think( this.delay );
			try
			{
				startTime += TimeUnit.MILLISECONDS.toNanos( this.delay );
				long t	= TimeUnit.NANOSECONDS.toMillis( startTime - System.nanoTime() );
				Thread.sleep( Math.max(0, t ) );
			} catch (InterruptedException e)
			{
				break;
			}
		}
	}

}

