package bomb;

import java.awt.geom.Rectangle2D;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class BombWall
{
	private int					x, y, width, height, xDiff, yDiff;
	private BufferedImage		iPic;
	private boolean				bPressed, bSelected;

	public BombWall( int x, int y, BufferedImage iPic )
	{
		super();
		this.x			= x;
		this.y			= y;
		this.iPic		= iPic;
		this.width		= this.iPic.getWidth();
		this.height		= this.iPic.getHeight();
		this.bPressed	= false;
		this.bSelected	= false;
		this.xDiff		= 0;
		this.yDiff		= 0;
	}

	public BufferedImage getIPic()
	{
		return this.iPic;
	}
	
	public boolean getbPressed()
	{
		return this.bPressed;
	}
	
	public void setbPressed( boolean bPressed )
	{
		this.bPressed	= bPressed;
	}
	
	public boolean getbSelected()
	{
		return this.bSelected;
	}
	
	public void setbSelected( boolean bSelected )
	{
		this.bSelected	= bSelected;
	}
	
	public double getXDiff() 
    {
        return this.xDiff;
    }
    
	public void setXDiff( double x )
    {
    	this.xDiff	= (int)x - this.x;
    }
	
	public double getYDiff() 
    {
        return this.yDiff;
    }
    
	public void setYDiff( double y )
    {
    	this.yDiff	= (int)y - this.y;
    }
	
	public int getX()
	{
		return this.x;
	}
	
	public void setX( double x )
	{
		this.x	= (int)x;
	}
	
	public int getY()
	{
		return this.y;
	}
	
	public void setY( double y )
	{
		this.y	= (int)y;
	}
	
	public int getWidth()
	{
		return this.width;
	}
	
	public int getHeight()
	{
		return this.height;
	}
	
	public boolean getbWallHit( double sweetyX, double sweetyY, int width, int height )
	{
		Rectangle2D a = new Rectangle2D.Double( this.x , this.y , this.width , this.height );
		Rectangle2D b = new Rectangle2D.Double( sweetyX, sweetyY, width, height );
		return a.intersects(b);
	}
	
	public String getMiddleHindrance( double sweetyX, double sweetyY, int width, int height )
	{
		if (	( sweetyY + height/2 >= this.y ) && ( sweetyY + height/2 < this.y + this.height ) &&
				( sweetyX + width > this.x ) && ( sweetyX + width < this.x + this.width/2 ) )
		{
			return "links";
		} else if (	( sweetyY + height/2 >= this.y ) && ( sweetyY + height/2 < this.y + this.height ) &&
					( sweetyX < this.x + this.width ) && ( sweetyX > this.x + this.width/2 ) )
		{
			return "rechts";
		} else if (	( sweetyX + width/2 >= this.x ) && ( sweetyX + width/2 < this.x + this.width ) &&
					( sweetyY + height/2 < this.y ) && ( sweetyY + height > this.y ) )
		{
			return "oben";
		} else if (	( sweetyX + width/2 >= this.x ) && ( sweetyX + width/2 < this.x + this.width ) &&
					( sweetyY + height/2 > this.y + this.height ) && ( sweetyY < this.y + this.height ) )
		{
			return "unten";
		}       
		return "";
	}
	
	public String getCornerHindrance( double sweetyX, double sweetyY, int width, int height, double xSpeed, double ySpeed )
	{
		// der Punkt unten rechts von Sweety wird mit dem Punkt oben links von der Wand verglichen
        if (( sweetyY + height >= this.y ) && ( sweetyY + height <= this.y + this.height ) &&
            ( sweetyX + width  >= this.x ) && ( sweetyX + width  <= this.x + this.width ))
        {
            //System.out.println("Erkannt das sweety unten rechts aneckt!");
            // falls 
            if ( (((Math.abs(( sweetyX + width ) - this.x )) < (Math.abs(( sweetyY + height ) - this.y )))) && ( Math.abs( ySpeed ) > 0.3 ) )
            {
                //System.out.print("Und er nimmt links!\n");
                return "links";
            } else
            {
                //System.out.print("Und er nimmt oben!\n");
                return "oben";
            }
        // der Punkt oben rechts von Sweety wird mit dem Punkt unten links von der Wand verglichen
        } else if (	( sweetyY > this.y ) && ( sweetyY < this.y + this.height ) &&
        			( sweetyX + width  > this.x ) && ( sweetyX + width  < this.x + this.width ))
        {
            //System.out.println("Erkannt das sweety oben rechts aneckt ");
            if (((Math.abs(( sweetyX + width) - this.x )) <= (Math.abs(( sweetyY ) - ( this.y + this.height )))))
            {
                return "links";
            } else
            {
                return "unten";
            }
        // der Punkt unten links von Sweety wird mit dem Punkt oben rechts von der Wand verglichen
        } else if (	( sweetyY + height >= this.y ) && ( sweetyY + height <= this.y + this.height ) &&
        			( sweetyX  >= this.x ) && ( sweetyX <= this.x + this.width ))
        {
            //System.out.println("Erkannt das sweety unten links aneckt!");
            if ( (((Math.abs(( sweetyX) - ( this.x + this.width ))) < (Math.abs(( sweetyY + height ) - this.y )))) && ( Math.abs( ySpeed ) > 0.3 ) )
            {
                return "rechts";
            } else
            {
                return "oben";
            }
        } else if (	( sweetyY > this.y ) && ( sweetyY < this.y + this.height ) &&
        			( sweetyX > this.x ) && ( sweetyX  < this.x + this.width ))
        {
            //System.out.println("Erkannt das sweety oben links aneckt!");
            if (((Math.abs(( sweetyX ) - ( this.x + this.width ))) <= (Math.abs(( sweetyY ) - ( this.y + this.height)))))
            {
                return "rechts";
            } else
            {
                return "unten";
            }
        }   
        return "";
	}

	public void render( Graphics2D g )
	{
		g.drawImage( this.iPic, x, y, null );
		if ( this.bSelected )
		{
			g.setColor( Color.RED );
			g.drawRect( x, y, this.width-1, this.height-1 );
		}
	}

}
